/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: TemporaryOutputStream.java 4483 2009-01-26 08:47:13Z gaellalire $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.stream.impl.file;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

/**
 *
 * @author Gael Lalire
 */
public class TemporaryOutputStream extends FileOutputStream {

    private File file;

    private File temporaryfile;

    public TemporaryOutputStream(final File temporaryfile, final File file) throws FileNotFoundException {
        super(temporaryfile);
        this.temporaryfile = temporaryfile;
        this.file = file;
    }

    @Override
    public void close() throws IOException {
        super.close();
        file.delete();
        temporaryfile.renameTo(file);
    }

    @Override
    protected void finalize() {
        temporaryfile.delete();
    }

}
